Name:    blktrace
Version: 1.2.0
Release: 16
Summary: Block IO tracer in the Linux kernel
License: GPLv2+
Source:  http://brick.kernel.dk/snaps/blktrace-%{version}.tar.bz2
URL:     https://git.kernel.dk/cgit/blktrace 

BuildRequires: gcc, git, xz, libaio-devel, python3, librsvg2-devel blktrace sysstat theora-tools gdb
Requires:      python3

Patch1:  0001-jhash-fix-annoying-gcc-fall-through-warnings.patch
Patch2:  0002-btt-devs-silence-warning-on-sprintf-overflow.patch
Patch3:  0003-btt-Fix-overlapping-IO-stats.patch
Patch4:  0004-blktrace-don-t-stop-tracer-if-not-setup-trace-succes.patch
Patch5:  0005-blkparse-remove-duplicated-entry-for-flag-M.patch
Patch6:  0006-btt-make-device-devno-use-PATH_MAX-to-avoid-overflow.patch
Patch7:  0007-make-btt-scripts-python3-ready.patch
Patch8:  0008-blktrace-remove-python2-dedpendency.patch
Patch9:  0009-btreplay-fix-device-IO-remap-functionality.patch
Patch10: 0010-blkparse-split-off-the-timestamp-correction-code-in-.patch
Patch11: 0011-blkparse-fix-absolute-timestamp-when-reading-from-fi.patch
Patch12: 0012-btt_plot.py-Use-with-open-as-.-context-manager.patch
Patch13: 0013-blkparse-Fix-device-in-event-tracking-error-messages.patch
Patch14: 0014-blkparse-Allow-request-tracking-on-non-md-dm-devices.patch
Patch15: 0015-blkparse-Initialize-and-test-for-undefined-request-t.patch

%description
blktrace is a block layer IO tracing mechanism which provides detailed
information about request queue operations up to user space. This is
valuable for diagnosing and fixing performance or application problems
relating to block layer io.

%package help
Summary: Including man files for blktrace
Requires: man

%description    help
This contains man files for the using of blktrace.

%prep
%autosetup -Sgit -n %{name}-%{version}

%build
%make_build -j1 all

%install
make dest=%{buildroot} prefix=%{buildroot}/%{_prefix} mandir=%{buildroot}/%{_mandir} install

%files
%defattr(-,root,root)
%doc README COPYING
%{_bindir}/blkparse
%{_bindir}/blkrawverify
%{_bindir}/bno_plot.py
%{_bindir}/btt
%{_bindir}/verify_blkparse
%{_bindir}/blkiomon
%{_bindir}/blktrace
%{_bindir}/btrace
%{_bindir}/btrecord
%{_bindir}/btreplay


%files help
%{_mandir}/man1/blkparse.*
%{_mandir}/man1/blkrawverify.*
%{_mandir}/man1/bno_plot.*
%{_mandir}/man1/btt.*
%{_mandir}/man1/verify_blkparse.*
%{_mandir}/man8/blkiomon.*
%{_mandir}/man8/blktrace.*
%{_mandir}/man8/btrace.*
%{_mandir}/man8/btrecord.*
%{_mandir}/man8/btreplay.*

%package -n iowatcher
Summary: Utility for visualizing block layer IO patterns and performance
Requires: blktrace sysstat theora-tools

%description -n iowatcher
iowatcher can plot multiple blktrace runs together, 
comparing the differences between different benchmark runs.

%files -n iowatcher
%doc README iowatcher/COPYING
%{_bindir}/iowatcher
%{_mandir}/man1/iowatcher.*

%changelog
* Thu Sep 10 2020 lihaotian <lihaotian9@huawei.com> - 1.2.0-16
- create iowatcher rpm sub-package

* Sun Jul 12 2020 Zhiqiang Liu <liuzhiqiang26@huawei.com> - 1.2.0-15
- backport upstream patches

* Wed Jul 1 2020 Wu Bo <wubo009@163.com> - 1.2.0-14
- rebuild package

* Wed Mar 18 2020 sunshihao<sunshihao@huawei.com> - 1.2.0-13
- Type:enhancemnet
- ID:NA
- SUG:restart
- DESCi:modify python2 expression to python3

* Tue Feb 25 2020 hy-euler <eulerstoragemt@huawei.com> - 1.2.0-12
- Type:enhancemnet
- ID:NA
- SUG:restart
- DESC:modify the URL to git web in spec file

* Mon Feb 17 2020 sunshihao<sunshihao@huawei.com> - 1.2.0-11
- Type:enhancemnet
- ID:NA
- SUG:restart
- DESC:blktrace remove python2 dependency

* Fri Aug 30 2019 zoujing<zoujing13@huawei.com> - 1.2.0-10
- Type:enhancemnet
- ID:NA
- SUG:restart
- DESC:openEuler Debranding

* Thu Aug 15 2019 Buildteam <buildteam@openeuler.org> - 1.2.0-9
- Package Initialization

